﻿Public Class Form1


    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load


        For index = 1 To 3
            UltraCalendarInfo1.Owners.Add(String.Format("Owner #{0}", index))
        Next
        Dim now As DateTime = DateTime.Now

        For index = 1 To 15
            Dim app As Infragistics.Win.UltraWinSchedule.Appointment = UltraCalendarInfo1.Appointments.Add(now.AddMinutes(index * 5), now.AddMinutes(index * 5 + 30), String.Format("Subject {0}", index))
            app.OwnerKey = String.Format("Owner #{0}", index Mod 3 + 1)
        Next

        UltraDayView1.EnsureTimeSlotVisible(now, True)


    End Sub



    Private Sub SelectAppointment(ByVal s As Infragistics.Win.UltraWinSchedule.Appointment)
        UltraCalendarInfo1.SelectedAppointments.Add(s)
    End Sub

    Private Sub UltraCalendarInfo1_AfterSelectedAppointmentsChange(sender As System.Object, e As System.EventArgs) Handles UltraCalendarInfo1.AfterSelectedAppointmentsChange
        If UltraDayView1.ModifierKeys = Keys.Shift Then

            RemoveHandler UltraCalendarInfo1.AfterSelectedAppointmentsChange, AddressOf UltraCalendarInfo1_AfterSelectedAppointmentsChange
            Dim endDate As DateTime = UltraCalendarInfo1.SelectedAppointments.Cast(Of Infragistics.Win.UltraWinSchedule.Appointment).Max(Function(app) app.StartDateTime)
            Dim startDate As DateTime = UltraCalendarInfo1.SelectedAppointments.Cast(Of Infragistics.Win.UltraWinSchedule.Appointment).Min(Function(app) app.StartDateTime)
            UltraCalendarInfo1.SelectedAppointments.Clear()
            Dim appList As List(Of Infragistics.Win.UltraWinSchedule.Appointment) = _
            UltraCalendarInfo1.Appointments.Cast(Of Infragistics.Win.UltraWinSchedule.Appointment).Where(Function(app) app.OwnerKey = UltraDayView1.ActiveOwner.Key).Where(Function(selApp) selApp.StartDateTime >= startDate And selApp.StartDateTime <= endDate).ToList()
            appList.ForEach(AddressOf SelectAppointment)
            AddHandler UltraCalendarInfo1.AfterSelectedAppointmentsChange, AddressOf UltraCalendarInfo1_AfterSelectedAppointmentsChange

        End If
    End Sub
End Class
